Index: trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 622)
@@ -4065,16 +3939,26 @@
     }
   } 
-#endif
+#endif // H_3D_IV_MERGE 
 
 #if H_3D_VSP
-#if MTK_VSP_FIX_E0172
-  if ( xAddVspCand( H_3D_VSP_POSITION, mrgCandIdx, &cDisInfo, iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, vspDir ) )
-#else
-  if ( xAddVspCand( H_3D_VSP_POSITION, mrgCandIdx, &cDisInfo, iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag ) )
-#endif
+  /////////////////////////////////////////////////
+  //////// VIEW SYNTHESIS PREDICTION (VSP) ////////
+  /////////////////////////////////////////////////
+
+  if ( xAddVspCand( mrgCandIdx, &cDisInfo, iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag ) )
+  {
     return;
+  }
+
   // early termination
   if (iCount == getSlice()->getMaxNumMergeCand())
+  {
     return;
+  }
+#endif
+#if H_3D
+  ///////////////////////////////////
+  //////// LEFT BOTTOM (A0) ////////
+  ///////////////////////////////////
 #endif
 
@@ -4103,16 +3987,8 @@
 #if H_3D_VSP
     if (pcCULeftBottom->getVSPFlag(uiLeftBottomPartIdx) == 1)
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-    {
-#endif
+    {
       vspFlag[iCount] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
       xInheritVSPDisInfo(pcCULeftBottom,uiLeftBottomPartIdx,iCount,inheritedVSPDisInfo);
     }
-#endif
-#if MTK_VSP_FIX_E0172
-      vspDir[iCount] = pcCULeftBottom->getVSPDir( uiLeftBottomPartIdx);
-    }
-#endif
 #endif
     if ( mrgCandIdx == iCount )
@@ -4127,4 +4003,10 @@
     return;
   }
+#if H_3D
+  ///////////////////////////////////
+  //////// LEFT ABOVE (B2) ////////
+  ///////////////////////////////////
+#endif
+
   // above left 
   if( iCount < 4 )
@@ -4154,16 +4036,8 @@
 #if H_3D_VSP
       if (pcCUAboveLeft->getVSPFlag(uiAboveLeftPartIdx) == 1)
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-      {
-#endif
+      {
         vspFlag[iCount] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
         xInheritVSPDisInfo(pcCUAboveLeft,uiAboveLeftPartIdx,iCount,inheritedVSPDisInfo);
       }
-#endif
-#if MTK_VSP_FIX_E0172
-        vspDir[iCount] = pcCUAboveLeft->getVSPDir( uiAboveLeftPartIdx);
-      }
-#endif
 #endif
       if ( mrgCandIdx == iCount )
@@ -4179,8 +4053,12 @@
     return;
   }
-#if QC_INRIA_MTK_MRG_E0126
+#if H_3D_IV_MERGE
+  ////////////////////////////////////////////////////
+  //////// SHIFTED IV (IvMCShift + IvDCShift) ////////
+  ////////////////////////////////////////////////////
+
   if(  ivMvPredFlag  ) 
   {
-    if(xAddIvMRGCand( mrgCandIdx,  iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, iPdmDir, acPdmMv, aiPdmRefIdx, iPosDmv, vspFlag))
+    if(xAddIvMRGCand( mrgCandIdx,  iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, ivCandDir, ivCandMv, ivCandRefIdx, posIvDC, vspFlag))
     {
       return;
@@ -4192,4 +4070,9 @@
     }
   }
+#endif
+#if H_3D
+  /////////////////////////////////
+  //////// Collocate (COL) ////////
+  /////////////////////////////////
 #endif
   if ( getSlice()->getEnableTMVPFlag())
@@ -4311,7 +4194,11 @@
       Bool bValid = true;
       if ( vspFlag[i] == 1 || vspFlag[j] == 1 )
+      {
         bValid = false;
+      }
       if( !m_pcSlice->getVPS()->getViewSynthesisPredFlag( m_pcSlice->getLayerIdInVps() ) )
+      {
         assert(bValid == true);
+      }
 #endif
 #if H_3D_VSP
@@ -4374,5 +4261,5 @@
   numValidMergeCand = uiArrayAddr;
 }
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
 inline Void TComDataCU::xInheritVSPDisInfo(TComDataCU* pcCURef, UInt uiAbsPartIdx, Int iCount, InheritedVSPDisInfo*  inheritedVSPDisInfo)
 {
@@ -4943,4 +4830,7 @@
 
   // use coldir.
+#if H_MV5
+  TComPic *pColPic = getSlice()->getRefPic( RefPicList(getSlice()->isInterB() ? 1-getSlice()->getColFromL0Flag() : 0), getSlice()->getColRefIdx());
+#else
 #if H_MV
   TComPic *pColPic;  
@@ -4955,4 +4845,5 @@
 #else
   TComPic *pColPic = getSlice()->getRefPic( RefPicList(getSlice()->isInterB() ? 1-getSlice()->getColFromL0Flag() : 0), getSlice()->getColRefIdx());
+#endif
 #endif
   TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
@@ -5770,7 +5661,4 @@
           pDInfo->m_acNBDV = cDispVec;
           pDInfo->m_aVIdxCan = cIDVInfo.m_aVIdxCan[iList][ curPos ];
-#if !MTK_DVMCP_FIX_E0172
-          assert(pDInfo->m_aVIdxCan == 0); //Notes from QC: only works for CTC
-#endif
 #if H_3D_NBDV_REF
           TComPic* picDepth = getSlice()->getIvPic( true, pDInfo->m_aVIdxCan );
@@ -5942,9 +5830,5 @@
           paIDVInfo->m_acMvCand[iList][ uiMvpDvPos ] = TComMv( cMvPred.getIDVHor(), cMvPred.getIDVVer() );
           //Notes from QC: DvMCP is implemented in a way that doesnE½t carry the reference view identifier as NBDV. It only works for CTC and needs to be fixed to be aligned with other part of the NBDV design.
-#if MTK_DVMCP_FIX_E0172
           paIDVInfo->m_aVIdxCan[iList][ uiMvpDvPos ] = cMvPred.getIDVVId();
-#else  
-          paIDVInfo->m_aVIdxCan[iList][ uiMvpDvPos ] = 0; 
-#endif
           paIDVInfo->m_bAvailab[iList][ uiMvpDvPos ] = true;
           paIDVInfo->m_bFound                        = true; 
@@ -6011,5 +5895,5 @@
   }
 }
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
 Void TComDataCU::setDvInfoSubParts( DisInfo cDvInfo, UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth )
 {
@@ -6150,6 +6034,7 @@
 TComDataCU::getInterViewMergeCands(UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* availableMcDc )
 {
-  TComSlice*    pcSlice         = getSlice ();  
-  Int iViewIndex = pDInfo->m_aVIdxCan;
+  TComSlice*    pcSlice = getSlice ();  
+  Int iViewIndex        = pDInfo->m_aVIdxCan;
+  
   //--- get base CU/PU and check prediction mode ---
   TComPic*    pcBasePic   = pcSlice->getIvPic( false, iViewIndex );
@@ -6174,38 +6059,27 @@
   TComMv      cDv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
   
-#if !QC_INRIA_MTK_MRG_E0126
-  Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + 2 ) >> 2 ) );
-  Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (cDv.getVer() + 2 ) >> 2 )); 
-
-  Int         iBaseCUAddr;
-  Int         iBaseAbsPartIdx;
-  pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY , iBaseCUAddr, iBaseAbsPartIdx );
-
-  TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
-#endif
-#if QC_INRIA_MTK_MRG_E0126
   Bool abPdmAvailable[8] =  {false, false, false, false, false, false, false, false};
-#else
-  Bool abPdmAvailable[4] = {false, false, false, false};
-#endif
 #if H_3D_NBDV
-#if QC_INRIA_MTK_MRG_E0126
   for( Int i = 0; i < 8; i++)
-#else
-  for( Int i = 0; i < 4; i++)
-#endif
   {
     pacPdmMv[i].setIDVFlag   (false);
   }
 #endif
-#if QC_INRIA_MTK_MRG_E0126
-  for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
-  {
+
+  ////////////////////////////////
+  /////// IvMC + IvMCShift ///////
+  ////////////////////////////////
+
+  for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)  
+  {
+    // iLoopCan == 0 --> IvMC
+    // iLoopCan == 1 --> IvMCShift 
+
     Int         iBaseCUAddr;
     Int         iBaseAbsPartIdx;
 
-    Int offsetW = (iLoopCan == 0) ? 0 : ( ((iWidth/2)*4)  + 4 );
+    Int offsetW = (iLoopCan == 0) ? 0 : ( ((iWidth /2)*4) + 4 );
     Int offsetH = (iLoopCan == 0) ? 0 : ( ((iHeight/2)*4) + 4 );
-    
+
     Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + offsetW + 2 ) >> 2 ) );
     Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (cDv.getVer() + offsetH + 2 ) >> 2 ) ); 
@@ -6213,28 +6087,28 @@
 
     TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
-#endif
-  if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
-  {
-    for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
-    {
-      RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
-
-      Bool stopLoop = false;
-      for(Int iLoop = 0; iLoop < 2 && !stopLoop; ++iLoop)
-      {
-        RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
-        TComMvField cBaseMvField;
-        pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
-        Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
-        if (iBaseRefIdx >= 0)
+    if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
+    {
+      // Loop reference picture list of current slice (X in spec). 
+      for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )       
+      {
+        RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+
+        Bool stopLoop = false;
+        // Loop reference picture list of candidate slice (Y in spec)
+        for(Int iLoop = 0; iLoop < 2 && !stopLoop; ++iLoop)
         {
-          Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
-          if (iBaseRefPOC != pcSlice->getPOC())    
+          RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
+          TComMvField cBaseMvField;
+          pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
+          Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
+          if (iBaseRefIdx >= 0)
           {
-            for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
+            Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
+            if (iBaseRefPOC != pcSlice->getPOC())    
             {
-              if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
+              for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
               {
-#if QC_INRIA_MTK_MRG_E0126
+                if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
+                {
                   abPdmAvailable[ (uiCurrRefListId + (iLoopCan<<2)) ] = true;
                   TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
@@ -6243,28 +6117,12 @@
                   cMv.setIDVHor    (cDv.getHor());                  
                   cMv.setIDVVer    (cDv.getVer());  
-#if MTK_DVMCP_FIX_E0172
                   cMv.setIDVVId    (iViewIndex); 
-#endif
 #endif
                   clipMv( cMv );
                   paiPdmRefIdx  [ (uiCurrRefListId + (iLoopCan<<2)) ] = iPdmRefIdx;
                   pacPdmMv      [ (uiCurrRefListId + (iLoopCan<<2)) ] = cMv;
-#else
-                abPdmAvailable[ uiCurrRefListId ] = true;
-                TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
-#if H_3D_NBDV 
-                cMv.setIDVFlag   (true);
-                cMv.setIDVHor    (cDv.getHor());                  
-                cMv.setIDVVer    (cDv.getVer());  
-#if MTK_DVMCP_FIX_E0172
-                cMv.setIDVVId    (iViewIndex); 
-#endif
-#endif
-                clipMv( cMv );
-                paiPdmRefIdx  [ uiCurrRefListId ] = iPdmRefIdx;
-                pacPdmMv      [ uiCurrRefListId ] = cMv;
-#endif
-                stopLoop = true;
-                break;
+                  stopLoop = true;
+                  break;
+                }
               }
             }
@@ -6274,15 +6132,14 @@
     }
   }
-#if QC_INRIA_MTK_MRG_E0126
-  }
-#endif
-#if QC_INRIA_MTK_MRG_E0126
   for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
   {
     availableMcDc[(iLoopCan << 1)] = ( abPdmAvailable[(iLoopCan<<2)] ? 1 : 0 ) + ( abPdmAvailable[1 + (iLoopCan<<2)] ? 2 : 0);
   }
-#else
-  availableMcDc[0] = ( abPdmAvailable[0] ? 1 : 0 ) + ( abPdmAvailable[1] ? 2 : 0 );
-#endif
+  
+  
+  ////////////////////////////////
+  /////// IvDC + IvDCShift ///////
+  ////////////////////////////////
+  
   for( Int iRefListId = 0; iRefListId < 2 ; iRefListId++ )
   {
@@ -6291,11 +6148,6 @@
     for( Int iPdmRefIdx = 0; iPdmRefIdx < iNumRefPics; iPdmRefIdx++ )
     {
-#if MTK_DIVMC_FIX_E0172
       if(( pcSlice->getRefPOC( eRefPicListDMV, iPdmRefIdx ) == pcSlice->getPOC()) && (pcSlice->getRefPic( eRefPicListDMV, iPdmRefIdx )->getViewIndex() == pDInfo->m_aVIdxCan))
-#else
-      if( pcSlice->getRefPOC( eRefPicListDMV, iPdmRefIdx ) == pcSlice->getPOC())
-#endif
-      {
-#if QC_INRIA_MTK_MRG_E0126
+      {
         for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
         {
@@ -6312,27 +6164,11 @@
         }
         break;
-#else
-        abPdmAvailable[ iRefListId+2 ] = true;
-        paiPdmRefIdx  [ iRefListId+2 ] = iPdmRefIdx;
-
-#if H_3D_NBDV_REF
-        TComMv cMv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
-#endif // H_3D_NBDV_REF
-        cMv.setVer(0);
-        clipMv( cMv );
-        pacPdmMv      [ iRefListId + 2] = cMv;
-        break;
-#endif
-      }
-    }
-  }
-#if QC_INRIA_MTK_MRG_E0126
+      }
+    }
+  }
   for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
   {
     availableMcDc[1 + (iLoopCan << 1)] = ( abPdmAvailable[2 + (iLoopCan<<2)] ? 1 : 0 ) + ( abPdmAvailable[3 + (iLoopCan<<2)] ? 2 : 0 );
   }
-#else
-  availableMcDc[1] = ( abPdmAvailable[2] ? 1 : 0 ) + ( abPdmAvailable[3] ? 2 : 0 );
-#endif
   return false;
 }
@@ -6406,5 +6242,5 @@
   for( UInt ui = 0; ui < uiCurrPartNumb; ui++ ) { m_dmmWedgeTabIdx[dmmType][uiAbsPartIdx+ui] = tabIdx; }
 }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
 Void  TComDataCU::setDmm2DeltaEndSubParts( Int iDelta, UInt uiAbsPartIdx, UInt uiDepth )
 {
Index: trunk/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 622)
@@ -197,7 +197,4 @@
   Char*         m_piVSPFlag;          ///< array of VSP flags to indicate whehter a block uses VSP or not
                                       ///< 0: non-VSP; 1: VSP
-#if MTK_VSP_FIX_E0172
-  Char*         m_piVSPDir;           ///< 0: LIST0; 1: LIST1
-#endif
 #endif
 #if H_3D_ARP
@@ -211,5 +208,5 @@
 #if H_3D_DIM_DMM
   UInt*         m_dmmWedgeTabIdx[DMM_NUM_TYPE]; 
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   Int*          m_dmm2DeltaEnd;
 #endif
@@ -256,16 +253,11 @@
   Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
 #if H_3D_VSP
-#if MTK_VSP_FIX_E0172
-  Bool          xAddVspCand( UChar ucVspMergePos, Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
-                             Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag, Int* vspDir );
-#else
-  Bool          xAddVspCand( UChar ucVspMergePos, Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
+  Bool          xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
                              Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag );
 #endif
-#endif
-#if QC_INRIA_MTK_MRG_E0126
-  Bool          xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int*   iPdmDir, TComMv* acPdmMv, 
-                               Int* aiPdmRefIdx, Int iPosDmv, Int* vspFlag ); 
-  Bool          xFirstDmvAvai( Int& iCount, TComMvField* pcMvFieldNeighbours, Int*  iPdmDir, Int iPosDmv, Int* vspFlag, Int& iFirDispCand );
+#if H_3D_IV_MERGE
+  Bool          xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int*   ivCandDir, TComMv* ivCandMv, 
+                               Int* ivCandRefIdx, Int posIvDC, Int* vspFlag ); 
+  Bool          xGetPosFirstAvailDmvCand( Int iCount, TComMvField* pcMvFieldNeighbours, Int*  ivCandDir, Int posIvDC, Int* vspFlag, Int& iFirDispCand );
 #endif
 
@@ -442,5 +434,5 @@
   template <typename T>
   Void          setSubPart            ( T bParameter, T* pbBaseLCU, UInt uiCUAddr, UInt uiCUDepth, UInt uiPUIdx );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
   template<typename T>
   Void          setSubPartT           ( T uiParameter, T* puhBaseLCU, UInt uiCUAddr, UInt uiCUDepth, UInt uiPUIdx );
@@ -471,7 +463,5 @@
 #if H_3D_NBDV
   Void          setDvInfoSubParts     ( DisInfo cDvInfo, UInt uiAbsPartIdx, UInt uiDepth );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
   Void          setDvInfoSubParts     ( DisInfo cDvInfo, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth);
-#endif
   DisInfo*      getDvInfo             ()                        { return m_pDvInfo;                 }
   DisInfo       getDvInfo             (UInt uiIdx)              { return m_pDvInfo[uiIdx];          }
@@ -555,5 +545,5 @@
   Void  setDmmWedgeTabIdxSubParts     ( UInt tabIdx, UInt dmmType, UInt uiAbsPartIdx, UInt uiDepth );
 
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   Int*  getDmm2DeltaEnd               ()                      { return m_dmm2DeltaEnd;        }
   Int   getDmm2DeltaEnd               ( UInt uiIdx )          { return m_dmm2DeltaEnd[uiIdx]; }
@@ -682,26 +672,15 @@
 #if H_3D_VSP
                                             , Int* vspFlag
-#if MTK_VSP_FIX_ALIGN_WD_E0172
                                             , InheritedVSPDisInfo*  inheritedVSPDisInfo
 #endif
-#if MTK_VSP_FIX_E0172
-                                            , Int* vspDir
-#endif
-#endif
                                             , Int& numValidMergeCand, Int mrgCandIdx = -1 );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
-  inline Void xInheritVSPDisInfo(TComDataCU* pcCURef, UInt uiAbsPartIdx, Int iCount,  InheritedVSPDisInfo*  inheritedVSPDisInfo);
-#endif
+
 #if H_3D_VSP
+  inline Void   xInheritVSPDisInfo(TComDataCU* pcCURef, UInt uiAbsPartIdx, Int iCount,  InheritedVSPDisInfo*  inheritedVSPDisInfo);
+
   Char*         getVSPFlag        ()                        { return m_piVSPFlag;          }
   Char          getVSPFlag        ( UInt uiIdx )            { return m_piVSPFlag[uiIdx];   }
   Void          setVSPFlag        ( UInt uiIdx, Int n )     { m_piVSPFlag[uiIdx] = n;      }
   Void          setVSPFlagSubParts( Char iVSPFlag, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
-#if MTK_VSP_FIX_E0172
-  Char*         getVSPDir          ()                        { return m_piVSPDir;                           }
-  Char          getVSPDir          ( UInt uiIdx )            { return m_piVSPDir[uiIdx];                  }
-  Void          setVSPDir          ( UInt uiIdx, Int n )     { m_piVSPDir[uiIdx] = n;  }
-  Void          setVSPDirSubParts  ( Char iVSPDir, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
-#endif
 #endif
   Void          deriveLeftRightTopIdxGeneral  ( UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLT, UInt& ruiPartIdxRT );
Index: trunk/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 622)
@@ -77,5 +77,5 @@
 } IDVInfo;
 #endif
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
 typedef struct _InheritedVSPDisCand 
 {
Index: trunk/source/Lib/TLibCommon/TComMv.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComMv.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComMv.h	(revision 622)
@@ -58,7 +58,5 @@
   Short m_iIDVHor;    
   Short m_iIDVVer;   
-#if MTK_DVMCP_FIX_E0172
   Short m_iIDVVId;  //view index of the IDV
-#endif
 #endif
 public:
@@ -75,7 +73,5 @@
   , m_iIDVHor(0)
   , m_iIDVVer(0)
-#if MTK_DVMCP_FIX_E0172
   , m_iIDVVId(0) 
-#endif
 #endif
   {
@@ -89,7 +85,5 @@
   , m_iIDVHor(0)
   , m_iIDVVer(0)
-#if MTK_DVMCP_FIX_E0172
-  , m_iIDVVId(0) 
-#endif
+  , m_iIDVVId(0)
 #endif
   {
@@ -106,7 +100,5 @@
  #if H_3D_NBDV
    m_bIDV = false; m_iIDVHor = m_iIDVVer = 0;
-#if MTK_DVMCP_FIX_E0172
    m_iIDVVId = 0; 
-#endif
 #endif
   }
@@ -115,7 +107,5 @@
   Void   setIDVVer  (Short i)                    {m_iIDVVer = i;}
   Void   setIDVFlag (Bool b )                    {m_bIDV    = b;}
-#if MTK_DVMCP_FIX_E0172
   Void   setIDVVId  (Short i)                    {m_iIDVVId = i;}
-#endif
 #endif
   // ------------------------------------------------------------------------------------------------------------------
@@ -131,7 +121,6 @@
   Short getIDVVer () const { return m_iIDVVer;       }
   Bool  getIDVFlag() const { return m_bIDV;          }
-#if MTK_DVMCP_FIX_E0172
   Short getIDVVId () const { return m_iIDVVId;       }
-#endif
+
 #endif
   // ------------------------------------------------------------------------------------------------------------------
Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 622)
@@ -456,5 +456,5 @@
         dmmSegmentation = &(g_dmmWedgeLists[ g_aucConvertToBit[iWidth] ][ pcCU->getDmmWedgeTabIdx( dimType, uiAbsPartIdx ) ]);
       } break;
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
     case( DMM2_IDX ):
       {
@@ -588,5 +588,5 @@
     pcCU->getPartIndexAndSize( iPartIdx, uiPartAddr, iWidth, iHeight );
 #if H_3D_VSP
-    if ( 0 == pcCU->getVSPFlag(uiPartAddr) )
+    if ( pcCU->getVSPFlag(uiPartAddr) == 0)
     {
 #endif
@@ -622,7 +622,11 @@
     {
       if ( xCheckIdenticalMotion( pcCU, uiPartAddr ) )
+      {
         xPredInterUniVSP( pcCU, uiPartAddr, iWidth, iHeight, REF_PIC_LIST_0, pcYuvPred );
+      }
       else
+      {
         xPredInterBiVSP ( pcCU, uiPartAddr, iWidth, iHeight, pcYuvPred );
+      }
     }
 #endif
@@ -635,5 +639,5 @@
 
 #if H_3D_VSP
-    if ( 0 == pcCU->getVSPFlag(uiPartAddr) )
+    if ( pcCU->getVSPFlag(uiPartAddr) == 0 )
     {
 #endif
@@ -669,7 +673,11 @@
     {
       if ( xCheckIdenticalMotion( pcCU, uiPartAddr ) )
+      {
         xPredInterUniVSP( pcCU, uiPartAddr, iWidth, iHeight, REF_PIC_LIST_0, pcYuvPred );
+      }
       else
+      {
         xPredInterBiVSP ( pcCU, uiPartAddr, iWidth, iHeight, pcYuvPred );
+      }
     }
 #endif
@@ -722,12 +730,5 @@
 {
   // Get depth reference
-#if MTK_VSP_FIX_E0172 
-  Int vspDir = pcCU->getVSPDir( uiPartAddr );
-  RefPicList privateRefPicList = (vspDir == 0) ? REF_PIC_LIST_0 : REF_PIC_LIST_1;
-  Int privateRefIdx = pcCU->getCUMvField( privateRefPicList )->getRefIdx( uiPartAddr );
-  Int depthRefViewIdx = pcCU->getSlice()->getRefPic(privateRefPicList, privateRefIdx)->getViewIndex();
-#else
-  Int depthRefViewIdx = pcCU->getDvInfo(uiPartAddr).m_aVIdxCan;
-#endif
+  Int       depthRefViewIdx = pcCU->getDvInfo(uiPartAddr).m_aVIdxCan;
   TComPic* pRefPicBaseDepth = pcCU->getSlice()->getIvPic (true, depthRefViewIdx );
   assert(pRefPicBaseDepth != NULL);
@@ -748,13 +749,5 @@
 
   // Do compensation
-#if MTK_VSP_FIX_ALIGN_WD_E0172 
   TComMv cDv  = pcCU->getDvInfo(uiPartAddr).m_acNBDV;
-#else
-#if MTK_VSP_FIX_E0172
-  TComMv cDv  = pcCU->getCUMvField( privateRefPicList )->getMv( uiPartAddr );
-#else
-  TComMv cDv  = pcCU->getCUMvField( eRefPicList )->getMv( uiPartAddr ); // cDv is the disparity vector derived from the neighbors
-#endif
-#endif // end of MTK_VSP_FIX_ALIGN_WD_E0172 
   pcCU->clipMv(cDv);
 
@@ -935,5 +928,7 @@
 
     if ( iRefIdx[iRefList] < 0 )
+    {
       continue;
+    }
     assert( iRefIdx[iRefList] < pcCU->getSlice()->getNumRefIdx(eRefPicList) );
 
@@ -2773,4 +2768,5 @@
 
 #if H_3D_DIM_DMM
+#if !SEC_DMM2_E0146_HHIFIX
 UInt TComPrediction::xPredWedgeFromIntra( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Int iDeltaEnd )
 {
@@ -2784,9 +2780,5 @@
   {
     UInt dimType =  getDimType( pcTempCU->getLumaIntraDir( uiTempPartIdx ) );
-#if SEC_DMM2_E0146
-    if( DMM1_IDX == dimType || DMM3_IDX == dimType )
-#else
     if( DMM1_IDX == dimType || DMM2_IDX == dimType || DMM3_IDX == dimType )
-#endif
     {
       // get offset between current and reference block
@@ -2813,9 +2805,5 @@
   {
     UInt dimType = getDimType( pcTempCU->getLumaIntraDir( uiTempPartIdx ) );
-#if SEC_DMM2_E0146
-    if( DMM1_IDX == dimType || DMM3_IDX == dimType )
-#else
     if( DMM1_IDX == dimType || DMM2_IDX == dimType || DMM3_IDX == dimType )
-#endif
     {
       // get offset between current and reference block
@@ -2849,4 +2837,5 @@
   return 0;
 }
+#endif
 
 UInt TComPrediction::xPredWedgeFromTex( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, UInt intraTabIdx )
@@ -2858,6 +2847,11 @@
   Int           uiColTexIntraDir = pcColTexCU->isIntra( uiTexPartIdx ) ? pcColTexCU->getLumaIntraDir( uiTexPartIdx ) : 255;
 
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
+  assert( uiColTexIntraDir > DC_IDX && uiColTexIntraDir < 35 );
+  return g_aauiWdgLstM3[g_aucConvertToBit[uiWidth]][uiColTexIntraDir-2].at(intraTabIdx);
+#else
   if( uiColTexIntraDir > DC_IDX && uiColTexIntraDir < 35 ) { return g_aauiWdgLstM3[g_aucConvertToBit[uiWidth]][uiColTexIntraDir-2].at(intraTabIdx); }
   else                                                     { return g_dmmWedgeNodeLists[(g_aucConvertToBit[uiWidth])].at(intraTabIdx).getPatternIdx(); }
+#endif
 }
 
@@ -2914,4 +2908,5 @@
 }
 
+#if !SEC_DMM2_E0146_HHIFIX
 Void TComPrediction::xGetBlockOffset( TComDataCU* pcCU, UInt uiAbsPartIdx, TComDataCU* pcRefCU, UInt uiRefAbsPartIdx, UInt& ruiOffsetX, UInt& ruiOffsetY )
 {
@@ -3302,4 +3297,5 @@
 }
 #endif
+#endif
 #if H_3D_DIM_RBC
 Void TComPrediction::xDeltaDCQuantScaleUp( TComDataCU* pcCU, Pel& rDeltaDC )
Index: trunk/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 622)
@@ -154,5 +154,7 @@
   Void xAssignBiSegDCs          ( Pel* ptrDst, UInt dstStride, Bool* biSegPattern, Int patternStride, Pel   valDC1, Pel   valDC2 );
 #if H_3D_DIM_DMM
+#if !SEC_DMM2_E0146_HHIFIX
   UInt xPredWedgeFromIntra      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Int iDeltaEnd = 0 );
+#endif
   UInt xPredWedgeFromTex        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, UInt intraTabIdx );
   Void xPredContourFromTex      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, TComWedgelet* pcContourWedge );
@@ -160,8 +162,10 @@
   Void xCopyTextureLumaBlock    ( TComDataCU* pcCU, UInt uiAbsPartIdx, Pel* piDestBlockY, UInt uiWidth, UInt uiHeight );
 
+#if !SEC_DMM2_E0146_HHIFIX
   Void xGetBlockOffset          ( TComDataCU* pcCU, UInt uiAbsPartIdx, TComDataCU* pcRefCU, UInt uiRefAbsPartIdx, UInt& ruiOffsetX, UInt& ruiOffsetY );
   Bool xGetWedgeIntraDirPredData( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiBlockSize, Int& riSlopeX, Int& riSlopeY, UInt& ruiStartPosX, UInt& ruiStartPosY );
   Void xGetWedgeIntraDirStartEnd( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiBlockSize, Int iDeltaX, Int iDeltaY, UInt uiPMSPosX, UInt uiPMSPosY, UChar& ruhXs, UChar& ruhYs, UChar& ruhXe, UChar& ruhYe, Int iDeltaEnd = 0 );
   UInt xGetWedgePatternIdx      ( UInt uiBlockSize, UChar uhXs, UChar uhYs, UChar uhXe, UChar uhYe );
+#endif
 #endif
 #if H_3D_DIM_RBC
Index: trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 622)
@@ -484,5 +484,5 @@
 }
 
-#if SCU_HS_FAST_DEPTH_INTRA_E0238
+#if SCU_HS_FAST_DEPTH_INTRA_E0238_HHIFIX
 
 UInt TComRdCost::calcVAR (Pel* pi0, Int stride, Int width, Int height, Int cuDepth)
Index: trunk/source/Lib/TLibCommon/TComRdCost.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 622)
@@ -235,5 +235,5 @@
   UInt    calcHAD(Int bitDepth, Pel* pi0, Int iStride0, Pel* pi1, Int iStride1, Int iWidth, Int iHeight );
   
-#if SCU_HS_FAST_DEPTH_INTRA_E0238
+#if SCU_HS_FAST_DEPTH_INTRA_E0238_HHIFIX
   UInt    calcVAR(Pel* pi0, Int stride, Int width, Int height, Int cuDepth);
 #endif  
Index: trunk/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 622)
@@ -347,5 +347,5 @@
 { //2x2   4x4   8x8 16x16 32x32 64x64
      0,    7,   10,   11,   11,   13 };
-#if LGE_PKU_DMM3_OVERLAP_E0159
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
 const UChar g_dmm3IntraTabIdxBits[6] =
 { //2x2   4x4   8x8 16x16 32x32 64x64
@@ -380,5 +380,8 @@
 Bool g_traceTU = true; 
 Bool g_disableHLSTrace = false; 
-UInt64 g_stopAtCounter   = 10803; 
+UInt64 g_stopAtCounter       = 48; 
+Bool g_traceCopyBack         = false; 
+Bool g_decTraceDispDer       = false; 
+Bool g_decTraceMvFromMerge   = false; 
 #endif
 #endif
@@ -611,5 +614,9 @@
 std::vector< std::vector< std::vector<UInt> > > g_aauiWdgLstM3;
 
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
+Void initWedgeLists( Bool initNodeList )
+#else
 Void initWedgeLists( Bool initRefinements )
+#endif
 {
   if( !g_dmmWedgeLists.empty() ) return;
@@ -624,4 +631,8 @@
     g_dmmWedgeRefLists.push_back( acWedgeRefList );
 
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
+    if( initNodeList )
+    {
+#endif
     // create WedgeNodeList
     std::vector<TComWedgeNode> acWedgeNodeList;
@@ -633,6 +644,8 @@
         cWedgeNode.setPatternIdx( uiPos );
 
+#if !LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
         if( initRefinements )
         {
+#endif
           UInt uiRefPos = 0;
           for( Int iOffS = -1; iOffS <= 1; iOffS++ )
@@ -681,9 +694,14 @@
             }
           }
+#if !LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
         }
+#endif
         acWedgeNodeList.push_back( cWedgeNode );
       }
     }
     g_dmmWedgeNodeLists.push_back( acWedgeNodeList );
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
+  }
+#endif
   }
   return;
Index: trunk/source/Lib/TLibCommon/TComRom.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.h	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComRom.h	(revision 622)
@@ -174,5 +174,9 @@
 extern       std::vector< std::vector< std::vector<UInt> > > g_aauiWdgLstM3;
 
+#if LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX
+Void initWedgeLists( Bool initNodeList = false );
+#else
 Void initWedgeLists( Bool initRefinements = false );
+#endif
 Void createWedgeList( UInt uiWidth, UInt uiHeight, std::vector<TComWedgelet> &racWedgeList, std::vector<TComWedgeRef> &racWedgeRefList, WedgeResolution eWedgeRes );
 Void addWedgeletToList( TComWedgelet cWedgelet, std::vector<TComWedgelet> &racWedgeList, std::vector<TComWedgeRef> &racWedgeRefList );
@@ -194,5 +198,5 @@
 
 #ifndef ENC_DEC_TRACE
-# define ENC_DEC_TRACE 0
+#define ENC_DEC_TRACE   0
 #endif
 
@@ -220,6 +224,9 @@
  extern Bool   g_tracePU; 
  extern Bool   g_traceTU; 
- extern Bool   g_disableHLSTrace; 
- extern UInt64 g_stopAtCounter; 
+ extern Bool   g_disableHLSTrace;       // USE g_HLSTraceEnable to toggle HLS trace. Not this one!
+ extern UInt64 g_stopAtCounter;         // Counter to set breakpoint. 
+ extern Bool   g_traceCopyBack;         // Output samples on copy back  
+ extern Bool   g_decTraceDispDer; // Trace derived disparity vectors (decoder only) 
+ extern Bool   g_decTraceMvFromMerge;   // Trace motion vectors obtained from merge (decoder only) 
 
 #define DTRACE_CU(x,y)             writeToTraceFile( x,y, g_traceCU );
